package com.duben.infinitefunjia.manager

import com.duben.infinitefunjia.utils.AppPreferencesManager
import com.duben.infinitefunjia.utils.TimeRender
import java.util.*

class ReadTimeCount {
    companion object {
        const val KEY_STORAGE_READ_TIME_COUNT = "READ_TIME_COUNT"

        val instance by lazy(LazyThreadSafetyMode.NONE) {
            ReadTimeCount()
        }
    }

    private var startReadTime: Date? = null // 开始阅读时间
    private var readTimeCountMap: String = ""

    fun getReadTime(): Array<String> {
        if (readTimeCountMap == "") {
            readTimeCountMap =
                AppPreferencesManager.get()
                    .getString(
                        KEY_STORAGE_READ_TIME_COUNT,
                        TimeRender.formatDate(Date()) + "*0"
                    )!!
        }
        val date = readTimeCountMap.split("*")[0]
        if (date != TimeRender.formatDate(Date())) {
            return TimeRender.ms2HMS_S(0)
        }

        val time = readTimeCountMap.split("*")[1].toInt()
        return TimeRender.ms2HMS_S(time)
    }

    /**
     * 存储阅读时间计时
     */
    private fun setReadTimeCount(count: Int) {
        if (readTimeCountMap == "") {
            readTimeCountMap =
                AppPreferencesManager.get()
                    .getString(
                        KEY_STORAGE_READ_TIME_COUNT,
                        TimeRender.formatDate(Date()) + "*0"
                    )!!
        }
        var time = readTimeCountMap.split("*")[1].toInt()
        time += count
        readTimeCountMap = TimeRender.formatDate(Date()) + "*" + time
        AppPreferencesManager.get().put(KEY_STORAGE_READ_TIME_COUNT, readTimeCountMap)
    }

    /**
     * 开始阅读计时
     */
    fun startCountReadTime() {
        startReadTime = Date()
    }

    /**
     * 停止阅读计时
     */
    fun endCountReadTime() {
        if (startReadTime == null) return
        val endReadTime = Date()
        val count = (endReadTime.time - startReadTime!!.time).toInt()
        startReadTime = null
        setReadTimeCount(count)
    }
}