package com.duben.infinitefunjia.mvp.presenters;

import android.content.Context;

import com.duben.library.net.neterror.BaseSubscriber;
import com.duben.library.net.neterror.Throwable;
import com.duben.infinitefunjia.MintsApplication;
import com.duben.infinitefunjia.common.DeviceInfo;
import com.duben.infinitefunjia.manager.AppHttpManager;
import com.duben.infinitefunjia.manager.UserManager;
import com.duben.infinitefunjia.mvp.model.BaseResponse;
import com.duben.infinitefunjia.mvp.model.UserBean;
import com.duben.infinitefunjia.utils.DeviceUuidFactory;

import java.util.HashMap;

public class TrackPresenter extends BaseTrackPresenter {

    public void visitorlogin() {
        HashMap<String, Object> vo = new HashMap<>();
        vo.put("device", new DeviceUuidFactory().getDeviceUuid());

        saveV6Terminal(vo);

        AppHttpManager.getInstance(loanApplication)
                .call(loanService.visitorlogin(vo),
                        new BaseSubscriber<BaseResponse<UserBean>>() {
                            @Override
                            public void onCompleted() {
                            }

                            @Override
                            public void onError(Throwable e) {
                            }

                            @Override
                            public void onNext(BaseResponse<UserBean> baseResponse) {
                                switch (baseResponse.getStatus()) {
                                    case 200: {
                                        UserManager.getInstance().saveUserInfo(baseResponse.getData());

                                        saveTerminalInfo();
                                    }
                                }
                            }
                        });
    }

    public void saveV6Terminal(HashMap<String, Object> vo) {
        try {
            Context context = MintsApplication.getContext();
            MintsApplication baseApplication = (MintsApplication) context;
            AppHttpManager.getInstance(baseApplication)
                    .call(baseApplication.getV6Service().saveV6TerminalInfoBefore(vo),
                            new BaseSubscriber<BaseResponse<Object>>() {
                                @Override
                                public void onCompleted() {
                                }

                                @Override
                                public void onError(Throwable e) {
                                }

                                @Override
                                public void onNext(BaseResponse<Object> baseResponse) {
                                }
                            });
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    public void saveTerminalInfo() {
        HashMap<String, Object> vo = new HashMap<>();
        DeviceInfo deviceInfo = DeviceInfo.Companion.getInstance();
        String macAddress = deviceInfo.getMacAddress();
        String mac = macAddress.replace(":", "");
        vo.put("androidid", deviceInfo.getAndroidId(null));
        vo.put("mac", mac);
        vo.put("mac1", macAddress);
        vo.put("os", "android");
        vo.put("model", deviceInfo.getBrand() + " " + deviceInfo.getMobileModel());
        vo.put("uuid", new DeviceUuidFactory().getDeviceUuid());
        vo.put("osversion", deviceInfo.getOSVersion());
        vo.put("appversion", deviceInfo.getVersionName());
        vo.put("oaid", MintsApplication.OAID);
        vo.put("imei", deviceInfo.getIMEI());
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.saveTerminalInfo(vo),
                        new BaseSubscriber<BaseResponse<Object>>() {
                            @Override
                            public void onCompleted() {
                            }

                            @Override
                            public void onError(Throwable e) {

                            }

                            @Override
                            public void onNext(BaseResponse<Object> baseResponse) {

                                switch (baseResponse.getStatus()) {
                                    case 200: {
                                        getMyInfo();
                                    }
                                }
                            }
                        });
    }

    public void getMyInfo() {
        HashMap<String, Object> vo = new HashMap<>();
        vo.put("os", "android");
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.getMyInfo(vo),
                        new BaseSubscriber<BaseResponse<UserBean>>() {
                            @Override
                            public void onCompleted() {
                            }

                            @Override
                            public void onError(Throwable e) {
                            }

                            @Override
                            public void onNext(BaseResponse<UserBean> baseResponse) {
                                switch (baseResponse.getStatus()) {
                                    case 200: {
                                        UserManager.getInstance().saveUserInfo(baseResponse.getData());
                                    }
                                }
                            }
                        });
    }
}
