package com.duben.infinitefunjia.ui.activitys

import android.view.View
import com.duben.library.net.neterror.BaseSubscriber
import com.duben.library.net.neterror.Throwable
import com.duben.infinitefunjia.R
import com.duben.infinitefunjia.manager.AppHttpManager
import com.duben.infinitefunjia.mvp.model.BaseResponse
import com.duben.infinitefunjia.mvp.model.OrderRecordBean
import com.duben.infinitefunjia.ui.activitys.base.BaseActivity
import com.duben.infinitefunjia.ui.adapter.HistoryAdapter
import com.scwang.smartrefresh.layout.api.RefreshLayout
import com.scwang.smartrefresh.layout.listener.OnRefreshListener
import kotlinx.android.synthetic.main.activity_history.*
import kotlinx.android.synthetic.main.header_layout.*

/**
 * 描述：历史记录
 * 作者：孟崔广
 */
class HistoryActivity : BaseActivity(), View.OnClickListener, OnRefreshListener {

    private var historyAdapter: HistoryAdapter? = null

    private var mOrderData: MutableList<OrderRecordBean.RecordsBean> = mutableListOf()

    override fun getContentViewLayoutID() = R.layout.activity_history

    override fun initViewsAndEvents() {
        tv_title.text = "历史记录"
        iv_left_icon.visibility = View.VISIBLE
        iv_left_icon.setImageResource(R.mipmap.ic_arrow_back)
        iv_left_icon.setOnClickListener(this)
        srl_drawcash.setOnRefreshListener(this)

        initRecy()
        getData()
    }

    override fun isApplyKitKatTranslucency() = false

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.iv_left_icon -> finish()
        }
    }

    override fun onRefresh(refreshLayout: RefreshLayout) {
        getData()
    }

    private fun getData() {
        AppHttpManager.getInstance(baseApplication)
            .call(baseApplication.loanService.cashOutRecords,
                object : BaseSubscriber<BaseResponse<OrderRecordBean>>() {
                    override fun onError(e: Throwable) {
                        srl_drawcash.finishRefresh(false)
                    }

                    override fun onNext(t: BaseResponse<OrderRecordBean>) {
                        if (t.status == 200) {
                            srl_drawcash.finishRefresh(true)

                            mOrderData.clear()
                            mOrderData.addAll(t.data.records)
                            historyAdapter?.notifyDataSetChanged()
                        } else {
                            srl_drawcash.finishRefresh(false)
                        }
                    }

                })
    }

    private fun initRecy() {
        historyAdapter = HistoryAdapter(this, mOrderData)
        recy_drawcash.adapter = historyAdapter
    }
}