package com.duben.infinitefunjia.ui.activitys

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import androidx.recyclerview.widget.LinearLayoutManager
import com.duben.infinitefunjia.R
import com.duben.infinitefunjia.common.Constant
import com.duben.infinitefunjia.manager.BookReadManager
import com.duben.infinitefunjia.mvp.model.*
import com.duben.infinitefunjia.mvp.presenters.WatchRecordPresenter
import com.duben.infinitefunjia.mvp.views.WatchRecordView
import com.duben.infinitefunjia.ui.activitys.base.BaseActivity
import com.duben.infinitefunjia.ui.adapter.WatchRecordAdapter
import kotlinx.android.synthetic.main.activity_watch_record.*
import kotlinx.android.synthetic.main.header_layout.*

class WatchRecordActivity : BaseActivity(), WatchRecordView {

    private val watchRecordPresenter by lazy { WatchRecordPresenter() }

    private var mWatchRecordAdapter: WatchRecordAdapter? = null
    private var datas = mutableListOf<BookBean>()

    override fun getContentViewLayoutID() = R.layout.activity_watch_record

    override fun initViewsAndEvents() {
        watchRecordPresenter.attachView(this)

        tv_title.text = "阅读记录"
        iv_left_icon.visibility = View.VISIBLE
        iv_left_icon.setImageResource(R.mipmap.ic_arrow_back)
        iv_left_icon.setOnClickListener { finish() }

        watchRecordPresenter.getHistory()

        mWatchRecordAdapter = WatchRecordAdapter()
        val emptyView = LayoutInflater.from(this).inflate(R.layout.item_empty_history, null)
        mWatchRecordAdapter?.setEmptyView(emptyView)
        mWatchRecordAdapter?.setNewInstance(datas)
        mWatchRecordAdapter?.setOnItemClickListener { adapter, view, position ->
            BookReadManager.instance.goReadPage(this,datas[position])
        }
        mWatchRecordAdapter?.setOnItemCollectClickListener(object :
            WatchRecordAdapter.OnItemCollectClickListener {
            override fun onItemCollectClick(bean: BookBean) {
                if (!bean.isCollect) {
                    bean.isCollect = true
                    watchRecordPresenter.collect(bean.id)
                } else {
                    bean.isCollect = false
                    watchRecordPresenter.cancelCollect(bean.id)
                }
                mWatchRecordAdapter?.notifyDataSetChanged()
            }
        })
        rv_watch_record.layoutManager = LinearLayoutManager(this)
        rv_watch_record.adapter = mWatchRecordAdapter
    }

    override fun isApplyKitKatTranslucency() = true

    override fun onDestroy() {
        super.onDestroy()
        watchRecordPresenter.detachView()
    }

    override fun getHistorySuc(historyBean: BookList2Bean) {
//        datas.clear()
        this.datas = historyBean.records
        mWatchRecordAdapter?.setNewInstance(historyBean.records)
        mWatchRecordAdapter?.notifyDataSetChanged()
    }

    override fun getHistoryFail() {

    }

    override fun collectSuc() {

    }

    override fun collectFail() {

    }

    override fun cancelCollectSuc() {

    }

    override fun cancelCollectFail() {

    }
}