package com.duben.infinitefunjia.ui.adapter

import androidx.fragment.app.Fragment
import androidx.viewpager2.adapter.FragmentStateAdapter
import com.duben.infinitefunjia.mvp.model.BookTypeBean
import com.duben.infinitefunjia.ui.fragment.BookListFragment

class HomeVideoPageAdapter(
    private val data: List<BookTypeBean>,
    fragment: Fragment
) :
    FragmentStateAdapter(fragment) {

    private val fragments = mutableMapOf<Int, Fragment>()

    override fun getItemId(position: Int): Long {
        return data[position].id.toLong()
    }

    override fun getItemCount() = data.size

    override fun createFragment(position: Int): Fragment {
        val newFragment = BookListFragment.newInstance(data[position].id.toInt(),position)
        fragments[position] = newFragment
        return newFragment
    }

    override fun containsItem(itemId: Long): Boolean {
        data.forEach {
            if (it.id.toLong() == itemId) {
                return true
            }
        }
        return false
    }

    fun getFragments(): MutableMap<Int, Fragment> {
        return fragments
    }

}