package com.duben.infinitefunjia.ui.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import com.duben.infinitefunjia.R;
import com.duben.infinitefunjia.mvp.model.BookBean;
import com.duben.library.utils.GlideUtils;
import com.youth.banner.adapter.BannerAdapter;

import java.util.List;


/**
 * 自定义布局，图片+标题
 */

public class ImageTitleAdapter extends BannerAdapter<BookBean, ImageTitleHolder> {

    private Context context;

    public ImageTitleAdapter(List<BookBean> datas) {
        super(datas);
    }

    @Override
    public ImageTitleHolder onCreateHolder(ViewGroup parent, int viewType) {
        context = parent.getContext();
        return new ImageTitleHolder(LayoutInflater.from(context).inflate(R.layout.banner_image_title, parent, false));
    }

    @Override
    public void onBindView(ImageTitleHolder holder, BookBean data, int position, int size) {
        if (data.getCarouselUrl() != null) {
            GlideUtils.INSTANCE.loadImageViewGifForCenterCrop(context, data.getCarouselUrl(), holder.imageView);
        }
        holder.title.setText(data.getTitle());
    }

}
