package com.duben.infinitefunjia.ui.widgets;

import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.WindowManager.LayoutParams;
import android.widget.ImageView;
import android.widget.TextView;

import com.duben.infinitefunjia.R;


/**
 * 支付返回弹窗
 */
public class BackPayDialog extends Dialog {
    private Context context;
    private LayoutParams lp;
    private DialogListener listener;

    private TextView tv_dialog_backpay;
    private TextView tv_dialog_backpay_content;
    private TextView tv_dialog_backpay_title;
    private ImageView iv_dialog_backpay_cancel;

    public BackPayDialog(Context context, DialogListener listener) {
        super(context, R.style.dialog);
        this.context = context;
        this.listener = listener;
        setContentView(R.layout.dialog_backpay);
        // 设置window属性
        lp = getWindow().getAttributes();
        lp.gravity = Gravity.CENTER;
        lp.width = LayoutParams.MATCH_PARENT;
        lp.windowAnimations = R.style.DialogAnimBottom;
        getWindow().setAttributes(lp);

        // 设置外部不可关闭
        setCancelable(false);
        setCanceledOnTouchOutside(false);
        setOnKeyListener(new OnKeyListener() {
            @Override
            public boolean onKey(DialogInterface dialogInterface, int i, KeyEvent keyEvent) {
                if (i == keyEvent.KEYCODE_BACK) {
                    return true;
                }
                return false;
            }
        });

        // 查找View
        tv_dialog_backpay = (TextView) findViewById(R.id.tv_dialog_backpay);
        tv_dialog_backpay_content = (TextView) findViewById(R.id.tv_dialog_backpay_content);
        tv_dialog_backpay_title = (TextView) findViewById(R.id.tv_dialog_backpay_title);
        iv_dialog_backpay_cancel = (ImageView) findViewById(R.id.iv_dialog_backpay_cancel);
        tv_dialog_backpay.setOnClickListener(listener);
        iv_dialog_backpay_cancel.setOnClickListener(listener);
    }

    public void setContent() {
        tv_dialog_backpay_title.setText("会员名额仅剩1%");
        tv_dialog_backpay_content.setText("离开后可能失去会员购买资格\n\n立即订阅 成为生活中的小帮手");
    }
}
