package com.duben.infinitefunjia.utils;

import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.RectF;
import android.text.style.ReplacementSpan;

public class RoundBackgroundColorSpan extends ReplacementSpan {
    private int bgColor;
    private int textColor;

    public RoundBackgroundColorSpan(int bgColor, int textColor) {
        super();
        this.bgColor = bgColor;
        this.textColor = textColor;
    }

    @Override
    public int getSize(Paint paint, CharSequence text, int start, int end, Paint.FontMetricsInt fm) {
        //设置宽度为文字宽度加16dp
        return ((int) paint.measureText(text, start, end) + BubbleUtils.px2dp(16));
    }

    @Override
    public void draw(Canvas canvas, CharSequence text, int start, int end, float x, int top, int y, int bottom, Paint paint) {
        int originalColor = paint.getColor();
        paint.setColor(this.bgColor);
        //画圆角矩形背景
        canvas.drawRoundRect(new RectF(x,
                        top + BubbleUtils.px2dp(3),
                        x + ((int) paint.measureText(text, start, end) + BubbleUtils.px2dp(16)),
                        bottom - BubbleUtils.px2dp(1)),
                BubbleUtils.px2dp(20),
                BubbleUtils.px2dp(20),
                paint);
        paint.setColor(this.textColor);
        //画文字,两边各增加8dp
        canvas.drawText(text, start, end, x + BubbleUtils.px2dp(8), y, paint);
        //将paint复原
        paint.setColor(originalColor);
    }
}